<?php
/**
* @version $Id: tpwhois.php Fri Dec 23 09:59:50 WST 2005 shaynebartlett
* @package J! Whois
* @copyright Copyright (C) 2005 theJ!factory. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* @package Tp Whois
* @by http://www.templateplazza.com
*/


// NO DIRECT ACCESS
defined( '_JEXEC' ) or die( 'Restricted access' );

include (JPATH_SITE.DS.'components'.DS.'com_tpwhois'.DS.'includes'.DS.'tpwhois.config.php');

// Languages
if (file_exists(JF_LANGUAGE . $mosConfig_lang.'.php')) {
  require_once(JF_LANGUAGE . $mosConfig_lang.'.php');
} else {
  require_once(JF_LANGUAGE . 'english.php');	
}

// +------------------------------
//	initialize script and navigate
// +------------------------------
$EP_Dev_Whois = new EP_Dev_Whois();
$EP_Dev_Whois->navigate($_REQUEST['task']);


/* ------------------------------------------------------------------ */
//	EP-Dev Whois Main Class
//	Main class of the script. Initializes and controls all aspects of
//	the whois script, including initiailizing core, etc.
//	Date: 3/29/2005
/* ------------------------------------------------------------------ */

class EP_Dev_Whois
{
	var $CORE;
	
	/* ------------------------------------------------------------------ */
	//	Constructor
	/* ------------------------------------------------------------------ */
	

	function EP_Dev_Whois()
	{
		// set error reporting level
		error_reporting(E_ALL ^ E_NOTICE);

		// absolute path
		$this->absolute_path = JPATH_SITE;

		// detect and (if necessary) set absolute path
	if ($this->absolute_path != "")
			$this->absolute_path = JF_COMPONENT;
			
			
			
	// try include and error if bad abs path
		if (!file_exists($this->absolute_path . "classes/global.php"))		
		{
			die("<div style=\"font-weight: bold; color: red;\">Error Loading J!Whois Script: The specified absolute path (" . JF_COMPONENT . " is incorrect.</div>");
		}

		// initialize core
		include_once(JF_COMPONENT . "classes/global.php");		
		$this->CORE = new EP_Dev_Whois_Global($this->absolute_path);
	}


	/* ------------------------------------------------------------------ */
	//	navigate to $task
	//	Calls on methods corresponding to $task
	/* ------------------------------------------------------------------ */
	
	function navigate($task)
	{
		switch ($task)
		{
			case "EmailImage" :
				// if no image verification, just redirect request to main page
				if (preg_match("/^[a-zA-Z0-9._%-]+@[a-zA-Z0-9-]+\.[a-zA-Z0-9\.-]+$/", $_REQUEST['email']))
					$this->CORE->SECURITYIMAGE->displaySecurityImage($_REQUEST['email']);
			break;


			case "SecurityImage" :
				// if no image verification, just redirect request to main page
				if (empty($this->CORE->CONFIG->SCRIPT['image_verification']))
				{
					$this->navigate("");
				}
				elseif (is_numeric($_REQUEST['code']))
					$this->CORE->SECURITYIMAGE->displayImage($_REQUEST['code']);
			break;

			case "WhoisReport" :
				$domain = $_REQUEST['domain'];
				$ext = $_REQUEST['ext'];

				// ensure extension exists
				if (empty($ext)) {
					//$this->CORE->ERROR->stop("no_extension");
					echo "<script> alert('".$this->CORE->ERROR->go("no_extension")."'); window.history.go(-1); </script>\n";
					exit;
				}

				// validate domain
				$this->CORE->DOMAINS->validateDomain($domain, $ext);

				// validate image (if enabled)
				if ($this->CORE->CONFIG->SCRIPT['image_verification'] == "gd")
				{
					if (is_numeric($_REQUEST['code']) && isset($_REQUEST['vcode']) && $this->CORE->SECURITYIMAGE->checkSecurityString($_REQUEST['code'], $_REQUEST['vcode'], $domain . $ext))
					{
						// show report
						$this->task_WhoisReport($domain, $ext);
					}
					else
					{
						// show image verification page
						$this->task_ImageVerification($domain, $ext);
					}
				}
				// show report
				$this->task_WhoisReport($domain, $ext);
			break;

			case "WhoisSearch" :
				$base_extensions = array();

				// search for all extensions
				foreach(array_keys($_REQUEST) as $current_key)
				{
					if (ereg("^ext[0-9]+$", $current_key))
						$base_extensions[] = $_REQUEST[$current_key];
				}

				$domains = explode("\n", str_replace("\r\n", "\n", $_REQUEST['domain']));

				if(empty($_REQUEST['domain'])) {
					echo "<script> alert('Please insert valid domain name!'); window.history.go(-1); </script>\n";
					exit;
				} else {
					if(strlen($_REQUEST['domain'])<=2) {
						echo "<script> alert('Please insert valid domain name!'); window.history.go(-1); </script>\n";
						exit;
					}
				}

				if ($this->CORE->CONFIG->BUYMODE['CONFIG']['enable'])
				{
					if(count($domains)) {
						foreach($domains as $domain)
						{
							$extensions = $base_extensions;
	
							// validate domain
							$this->CORE->DOMAINS->validateDomain($domain, $extensions);
	
							// send to search method
							if (!empty($whoisQueries))
								$whoisQueries = array_merge($this->go_WhoisSearch($domain, $extensions, ($_REQUEST['skip_additional'] == "1")), $whoisQueries);
							else
								$whoisQueries = $this->go_WhoisSearch($domain, $extensions, ($_REQUEST['skip_additional'] == "1"));
						}
					}

					// display results
					$this->task_Results($whoisQueries);
				}
				else
				{
					$extensions = $base_extensions;

					// ensure extension exists
					if (empty($extensions[0])) {
						//$this->CORE->ERROR->stop("no_extension");
						echo "<script> alert('".$this->CORE->ERROR->go("no_extension")."'); window.history.go(-1); </script>\n";
						exit;
					}

					// validate domain
					$this->CORE->DOMAINS->validateDomain($domains[0], $extensions);

					// show whois report
					$this->task_WhoisReport($domains[0], $extensions[0]);
				}
			break;

			case "MultipleWhoisSearch" :
				$this->task_MultipleWhoisSearch();
			break;


			default: $this->task_Front();
		}
	}


	/* ------------------------------------------------------------------ */
	//	Whois Search
	//	Performs whois search on $domain with $form_extensions while
	//	incorporating additional script features.
	//	RETURN: array of whois query objects
	/* ------------------------------------------------------------------ */
	
	function go_WhoisSearch($domain, $form_extensions, $skip_autosearch = false)
	{
		// +------------------------------
		//	Log Search Parameters in session
		// +------------------------------
		$this->CORE->USER->setValue("domain", $domain);
		$this->CORE->USER->setValue("extension", $form_extensions[0]);
		$this->CORE->USER->setValue("extensions", $form_extensions);

		if (!$skip_autosearch)
		{
			// append auto-search extensions, remove duplicates
			$extensions = array_unique(array_merge($form_extensions, $this->CORE->DOMAINS->getAutoSearchExtensions()));
		}
		else
		{
			$extensions = $form_extensions;
		}

		// ensure extension exists
		if (empty($extensions)) {
			//$this->CORE->ERROR->stop("no_extension");
			echo "<script> alert('".$this->CORE->ERROR->go("no_extension")."'); window.history.go(-1); </script>\n";
			exit;
		}

		// detect log type & process logs accordingly
		if (!$this->CORE->CONFIG->SCRIPT['LOGS']['all'] && !empty($form_extensions))
			$this->CORE->LOG->update($domain, $form_extensions);
		else
			$this->CORE->LOG->update($domain, $extensions);

		// extension count
		$i=0;
		if(count($extensions)) {
			foreach($extensions as $current_ext)
			{
				// only process if extension not blank
				if (!empty($current_ext))
				{
					// perform whois lookup
					$whois_queries[$i] = $this->CORE->whoisRequest($domain, $current_ext);
					$whois_queries[$i]->lookup();
					$extensions_used[$current_ext] = $whois_queries[$i]->isAvailable();
					$i++;
				}
			}
		}

// +------------------------------
		//	Suggested Queries Code
		// +------------------------------

		// if user gave extensions and domain suggestions are enabled
		$suggested_domains_enabled = $this->CORE->DOMAINS->getDomainSuggestions("", "");
		if (!$skip_autosearch && !empty($form_extensions) && !empty($suggested_domains_enabled))
		{
			$suggested_domains = array();
			foreach($form_extensions as $current_extension)
			{
				// if domain + extension was unavailable
				if (isset($extensions_used[$current_extension]) && $extensions_used[$current_extension] == false)
					$suggested_domains = array_merge($suggested_domains, $this->CORE->DOMAINS->getDomainSuggestions($domain, $current_extension));
			}

			// ensure no duplicates
			$suggested_domains = array_unique($suggested_domains);
			$suggestedDomains = array();
			$suggestedExtensions = array();

			// cycle through suggested domains to validate them
			foreach($suggested_domains as $current_domain)
			{
				$current_extensions = array();
				
				if($this->CORE->DOMAINS->validateDomain($current_domain, $current_extensions, true))
				{
					$suggestedDomains[] = $current_domain;
					$suggestedExtensions[] = $current_extensions;
				}	
			}


			$logsDomains = array();
			$logsExtensions = array();
			$next = count($whois_queries);

			// cycle through suggested domains / extensions and process them if the combos have not already
			// been processed earlier.
			for($i=0; $i<count($suggestedDomains); $i++)
			{
				$success = false;

				foreach($suggestedExtensions[$i] as $current_ext)
				{
					// only process if extension not blank and domain.ext has not been used above
					if (!empty($current_ext) && ($suggestedDomains[$i] != $domain || !in_array($current_ext, $extensions)))
					{
						// perform whois lookup
						$whois_queries[$next] = $this->CORE->whoisRequest($suggestedDomains[$i], $current_ext);
						$whois_queries[$next]->lookup();
						if (!$whois_queries[$next]->isAvailable())
							unset($whois_queries[$next]);
						else
							$next++;

						$success = true;
					}
				}

				if ($success)
				{
					$logsDomains[] = $domain;
					$logsExtensions[] = $suggestedExtensions[$i];
				}
			}


			// detect log type & process logs accordingly (again)
			if ($this->CORE->CONFIG->SCRIPT['LOGS']['enable'] && $this->CORE->CONFIG->SCRIPT['LOGS']['all'])
			{
				for($i=0; $i<count($logsDomains); $i++)
				{
					$this->CORE->LOG->update($logsDomains[$i], $logsExtensions[$i]);
				}
			}
		}
		return $whois_queries;
	}


	/* ------------------------------------------------------------------ */
	//	Front task
	//	Displays front task
	/* ------------------------------------------------------------------ */
	
	function task_Front()
	{
		// display main task
		$this->CORE->DISPLAY->constructtask("main", "", "");
		$this->CORE->DISPLAY->displaytask();
	}


	/* ------------------------------------------------------------------ */
	//	Multiple Whois Search task
	//	Displays multiple TLD check task
	/* ------------------------------------------------------------------ */
	
	function task_MultipleWhoisSearch()
	{
		// display main task
		$this->CORE->DISPLAY->constructtask("multiple_tlds", "", "");
		$this->CORE->DISPLAY->displaytask();
	}


	/* ------------------------------------------------------------------ */
	//	Whois Report task
	//	Calls & Displays whois report for $domain and $ext
	/* ------------------------------------------------------------------ */
	
	function task_WhoisReport($domain, $ext)
	{
		// +------------------------------
		//	Log Search Parameters in session
		// +------------------------------
		$this->CORE->USER->setValue("domain", $domain);
		$this->CORE->USER->setValue("extension", $ext);
		$this->CORE->USER->setValue("extensions", array($ext));

		// Log query
		// Log query
		if ($this->CORE->CONFIG->SCRIPT['LOGS']['enable'])
		$this->CORE->LOG->update($domain, $ext);
		
		// +------------------------------
		//	Generate & Display task
		// +------------------------------
		// load task template
		$this->CORE->DISPLAY->constructtask("report", "", _JF_WHOIS_REPORT);

		// generate whois request
		$whois_query = $this->CORE->whoisRequest($domain, $ext);

		// perform full whois lookup
		$whois_query->lookup(true);

		// reload display
		$this->CORE->DISPLAY->reloadCore($this->CORE);

		// parse for whoisreport
		$this->CORE->DISPLAY->customParse("whoisreport", $whois_query->getWhoisReport());

		// display task
		$this->CORE->DISPLAY->displaytask();
	}

/* ------------------------------------------------------------------ */
	//	Image Verification Page
	//	Displays image verification page
	/* ------------------------------------------------------------------ */
	
	function page_ImageVerification($domain, $ext)
	{
		// +------------------------------
		//	Log Search Parameters in session
		// +------------------------------
		$this->CORE->USER->setValue("domain", $domain);
		$this->CORE->USER->setValue("extension", $ext);
		$this->CORE->USER->setValue("extensions", array($ext));

		// load image verificaiton template
		$this->CORE->DISPLAY->constructPage("image_verification", "", "Image Verification");

		// parse for image code
		$this->CORE->DISPLAY->customParse("image-code", $this->CORE->SECURITYIMAGE->getRandomNumber($domain . $ext));
		$this->CORE->DISPLAY->customParse("domain", $domain);
		$this->CORE->DISPLAY->customParse("ext", $ext);

		// display page
		$this->CORE->DISPLAY->displayPage();
	}

	/* ------------------------------------------------------------------ */
	//	Results task
	//	Organizes array of query objects ($whois_queries) according to
	//	results task template and displays result task
	/* ------------------------------------------------------------------ */
	
	function task_Results($whois_queries)
	{
		// load task template
		$this->CORE->DISPLAY->constructtask("results", "", _JF_SEARCH_RESULTS);

		$available_array = array();
		$unavailable_array = array();

		// cycle through queries
		foreach($whois_queries as $current_query)
		{
			// detect if query resulted in available and sort accordingly
			if ($current_query->isAvailable())
				$available_array[] = $current_query;
			else
				$unavailable_array[] = $current_query;
		}

		// parse for available/unavailable extensions
		$this->CORE->DISPLAY->parseAvailableDomains($available_array);
		$this->CORE->DISPLAY->parseUnavailableDomains($unavailable_array);

		// display task
		$this->CORE->DISPLAY->displaytask();
	}

}
